
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
        <link rel="canonical" href="https://autovtools.gitlab.io/autovrtfm/usage/rdn/dns/">
      
      
        <link rel="prev" href="../tun/">
      
      
        <link rel="next" href="../../rtfm/">
      
      
      <link rel="icon" href="../../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.5.3, mkdocs-material-9.4.6">
    
    
      
        <title>DNS - autovnet</title>
      
    
    
      <link rel="stylesheet" href="../../../assets/stylesheets/main.35e1ed30.min.css">
      
        
        <link rel="stylesheet" href="../../../assets/stylesheets/palette.356b1318.min.css">
      
      


    
    
      
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
  </head>
  
  
    
    
      
    
    
    
    
    <body dir="ltr" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo">
  
    
    
      <script>var palette=__md_get("__palette");if(palette&&"object"==typeof palette.color)for(var key of Object.keys(palette.color))document.body.setAttribute("data-md-color-"+key,palette.color[key])</script>
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#dns" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

  

<header class="md-header md-header--shadow md-header--lifted" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-header__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            autovnet
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              DNS
            
          </span>
        </div>
      </div>
    </div>
    
      
        <form class="md-header__option" data-md-component="palette">
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to light mode"  type="radio" name="__palette" id="__palette_1">
    
      <label class="md-header__button md-icon" title="Switch to light mode" for="__palette_2" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 7H7a5 5 0 0 0-5 5 5 5 0 0 0 5 5h10a5 5 0 0 0 5-5 5 5 0 0 0-5-5m0 8a3 3 0 0 1-3-3 3 3 0 0 1 3-3 3 3 0 0 1 3 3 3 3 0 0 1-3 3Z"/></svg>
      </label>
    
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="default" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to dark mode"  type="radio" name="__palette" id="__palette_2">
    
      <label class="md-header__button md-icon" title="Switch to dark mode" for="__palette_1" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 6H7c-3.31 0-6 2.69-6 6s2.69 6 6 6h10c3.31 0 6-2.69 6-6s-2.69-6-6-6zm0 10H7c-2.21 0-4-1.79-4-4s1.79-4 4-4h10c2.21 0 4 1.79 4 4s-1.79 4-4 4zM7 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></svg>
      </label>
    
  
</form>
      
    
    
    
      <label class="md-header__button md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
        <div class="md-search__suggest" data-md-component="search-suggest"></div>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list" role="presentation"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
      </div>
    
  </nav>
  
    
      
<nav class="md-tabs" aria-label="Tabs" data-md-component="tabs">
  <div class="md-grid">
    <ul class="md-tabs__list">
      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../.." class="md-tabs__link">
          
  
  Home

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../rtfm/" class="md-tabs__link">
          
  
  RTFM

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../demo/" class="md-tabs__link">
          
  
  Demo

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../setup/" class="md-tabs__link">
          
  
  Setup

        </a>
      </li>
    
  

      
        
  
  
    
  
  
    
    
      <li class="md-tabs__item md-tabs__item--active">
        <a href="../../" class="md-tabs__link">
          
  
  Usage

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../help/" class="md-tabs__link">
          
  
  Reference

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../resources/faq/" class="md-tabs__link">
          
  
  Resources

        </a>
      </li>
    
  

      
    </ul>
  </div>
</nav>
    
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


  


  

<nav class="md-nav md-nav--primary md-nav--lifted md-nav--integrated" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-nav__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    autovnet
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_1" >
        
          
          <label class="md-nav__link" for="__nav_1" id="__nav_1_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Home
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_1_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_1">
            <span class="md-nav__icon md-icon"></span>
            Home
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../.." class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_2" >
        
          
          <label class="md-nav__link" for="__nav_2" id="__nav_2_label" tabindex="">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_2">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/paradigm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Paradigm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/autovnet/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/goals/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Goals
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_3" >
        
          
          <label class="md-nav__link" for="__nav_3" id="__nav_3_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Demo
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_3">
            <span class="md-nav__icon md-icon"></span>
            Demo
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Demo
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/callback/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Callback
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_4" >
        
          
          <label class="md-nav__link" for="__nav_4" id="__nav_4_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Setup
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_4">
            <span class="md-nav__icon md-icon"></span>
            Setup
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Quick Start
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/network/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Network Design
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/install/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Install
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/configure/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Configure
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/local/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Local Install
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
    
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--active md-nav__item--section md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5" checked>
        
          
          <label class="md-nav__link" for="__nav_5" id="__nav_5_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Usage
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_5_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5">
            <span class="md-nav__icon md-icon"></span>
            Usage
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Usage
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5_2" checked>
        
          
          <label class="md-nav__link" for="__nav_5_2" id="__nav_5_2_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RDN
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_2_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5_2">
            <span class="md-nav__icon md-icon"></span>
            RDN
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RDN
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../listen/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Listen
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../tun/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Tun
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          
  
  <span class="md-ellipsis">
    DNS
  </span>
  

          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        
  
  <span class="md-ellipsis">
    DNS
  </span>
  

      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#intro" class="md-nav__link">
    Intro
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#register" class="md-nav__link">
    register
  </a>
  
    <nav class="md-nav" aria-label="register">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#no-args" class="md-nav__link">
    No Args
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#chosen-ip" class="md-nav__link">
    Chosen IP
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#chosen-dns-name" class="md-nav__link">
    Chosen DNS Name
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#chosen-record" class="md-nav__link">
    Chosen Record
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#detach-register-unregister" class="md-nav__link">
    Detach Register, Unregister
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#save-load-from-file" class="md-nav__link">
    Save / Load From File
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#but-i-cant-connect-to-the-random-ip" class="md-nav__link">
    But I can't connect to the random IP?
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#listen-integration" class="md-nav__link">
    listen integration
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#tun-integration" class="md-nav__link">
    tun integration
  </a>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_3" >
        
          
          <label class="md-nav__link" for="__nav_5_3" id="__nav_5_3_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_3">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/apt/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    APT
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/pasta/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Pasta
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_4" >
        
          
          <label class="md-nav__link" for="__nav_5_4" id="__nav_5_4_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Pwn
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_4">
            <span class="md-nav__icon md-icon"></span>
            Pwn
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwn
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/share/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    File Hosting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/pwncat/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwncat
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/winrm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    evil-winrm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/metasploit/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/merlin/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    merlin
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/sliver/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    sliver
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/ligolo_ng/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    ligolo-ng
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_5" >
        
          
          <label class="md-nav__link" for="__nav_5_5" id="__nav_5_5_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_5">
            <span class="md-nav__icon md-icon"></span>
            Collaboration
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/svc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Services
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/fs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Directories
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/vnc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Screen Sharing
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/hedgedoc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/msfdb/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    msfdb
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/gitea/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    gitea
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/focalboard/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    focalboard
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/drawio/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    drawio
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/cyberchef/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    cyberchef
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/matrix/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    matrix
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/nextcloud/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    nextcloud
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/owncast/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    owncast
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_6" >
        
          
          <label class="md-nav__link" for="__nav_5_6" id="__nav_5_6_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Util
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_6">
            <span class="md-nav__icon md-icon"></span>
            Util
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    util
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/tmp/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    tmp
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_6" >
        
          
          <label class="md-nav__link" for="__nav_6" id="__nav_6_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Reference
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_6">
            <span class="md-nav__icon md-icon"></span>
            Reference
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../help/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_7" >
        
          
          <label class="md-nav__link" for="__nav_7" id="__nav_7_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Resources
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_7_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_7">
            <span class="md-nav__icon md-icon"></span>
            Resources
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/faq/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    FAQ
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/troubleshooting/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Troubleshooting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/changelog/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Changelog
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/wild/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    In The Wild
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/refs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    References
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  

  
  


<h1 id="dns">dns<a class="headerlink" href="#dns" title="Permanent link">&para;</a></h1>
<div class="toc">
<ul>
<li><a href="#dns">dns</a><ul>
<li><a href="#intro">Intro</a></li>
<li><a href="#register">register</a><ul>
<li><a href="#no-args">No Args</a></li>
<li><a href="#chosen-ip">Chosen IP</a></li>
<li><a href="#chosen-dns-name">Chosen DNS Name</a></li>
<li><a href="#chosen-record">Chosen Record</a></li>
<li><a href="#detach-register-unregister">Detach Register, Unregister</a></li>
<li><a href="#save-load-from-file">Save / Load From File</a></li>
<li><a href="#but-i-cant-connect-to-the-random-ip">But I can't connect to the random IP?</a></li>
</ul>
</li>
<li><a href="#listen-integration">listen integration</a></li>
<li><a href="#tun-integration">tun integration</a></li>
</ul>
</li>
</ul>
</div>
<h2 id="intro">Intro<a class="headerlink" href="#intro" title="Permanent link">&para;</a></h2>
<p>Most normal, real-world internet traffic (web browsing, etc.) uses <a href="https://en.wikipedia.org/wiki/Domain_Name_System"><code>dns</code></a> to resolve a human-friendly name like <code>google.com</code> to a numeric <a href="https://en.wikipedia.org/wiki/IP_address">IP address</a> that your computer understands.</p>
<p>In the real world, people pay money to "register" a <code>dns</code> record.
After paying one of the right companies, someone on the other side of the world can access your website via the human-friendly name you associated with our IP.</p>
<p>Malicious actors often also register <code>dns</code> names as part of their C2 infrastructure.</p>
<ul>
<li>This can help make malicious traffic look more "normal"</li>
<li>By changing the <code>dns</code> record later, the actor can change which C2 server(s) that malware will connect to</li>
</ul>
<p>For similar reasons, and to better emulate real-world actors, we want to support creating <code>dns</code> records as part of our <a href="../../../rtfm/">RTFM</a> infrastructure.</p>
<p>If you game admin <a href="../../../rtfm/autovnet/#dns">followed the <code>dns</code> configuration guide</a>,
then your <code>autovnet</code> server supports <code>dns</code> and will allow <code>autovnet</code> players to register <code>dns</code> names (for free, obviously) that will work within your game network.</p>
<h2 id="register"><code>register</code><a class="headerlink" href="#register" title="Permanent link">&para;</a></h2>
<p>You can use the <code>autovnet rtfm dns register</code> command to create <code>dns</code> records.</p>
<p>All records you create will end in a custom <a href="https://en.wikipedia.org/wiki/Top-level_domain">TLD</a>,
<code>.avn</code> (for <code>autovnet</code>) by default.</p>
<h3 id="no-args">No Args<a class="headerlink" href="#no-args" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>register
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Connecting...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns<span class="w"> </span>ready!
longing.salary.avn:10.229.134.116
</code></pre></div>
<p>With no arguments, <code>register</code> chooses a random <code>dns</code> name for you, and a random IP.</p>
<p>The <code>dns</code> record is valid until you <code>CTRL+C</code> out of the register command.</p>
<p>We can confirm the registration worked by performing a <code>dns</code> query with <code>dig</code>
<div class="highlight"><pre><span></span><code><span class="c1"># Any system can now resolve the registered name</span>
$<span class="w"> </span>dig<span class="w"> </span>longing.salary.avn<span class="w"> </span>+short
<span class="m">10</span>.229.134.116
</code></pre></div></p>
<h3 id="chosen-ip">Chosen IP<a class="headerlink" href="#chosen-ip" title="Permanent link">&para;</a></h3>
<p>If you already have an IP - perhaps your <code>map_ip</code> from a <a href="../tun/"><code>tun</code></a> - you can give it to <code>register</code>,
which will generate a random <code>dns</code> record for it.</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>register<span class="w"> </span><span class="m">10</span>.231.52.107
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Connecting...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns<span class="w"> </span>ready!
disgusted.score.avn:10.231.52.107
</code></pre></div>
<h3 id="chosen-dns-name">Chosen DNS Name<a class="headerlink" href="#chosen-dns-name" title="Permanent link">&para;</a></h3>
<p>If you have a special name that you want to use - perhaps a human-friendly name for a game service - you can pass that to <code>register</code>, too.</p>
<p>If you just pass a name, then <code>register</code> will choose a random IP for you.</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>register<span class="w"> </span>scoreboard
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Connecting...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns<span class="w"> </span>ready!
scoreboard.avn:10.216.60.142
</code></pre></div>
<p>Notice that <code>.avn</code> was added to your registration for you.
This is an intentional design choice; all game queries will end in the game TLD,
and game registrations won't break real <code>dns</code> needed for internet access, etc.</p>
<p>You can use the tld explictly if you prefer:
<div class="highlight"><pre><span></span><code>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>register<span class="w"> </span>foo.avn<span class="w">   </span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Connecting...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns<span class="w"> </span>ready!
foo.avn:10.242.229.186
</code></pre></div></p>
<h3 id="chosen-record">Chosen Record<a class="headerlink" href="#chosen-record" title="Permanent link">&para;</a></h3>
<p>Know both the name you want and the IP?
Separate them with a colon like <code>name:ip</code>!</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>register<span class="w"> </span>foo.avn:10.239.77.243
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Connecting...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns<span class="w"> </span>ready!
foo.avn:10.239.77.243
</code></pre></div>
<h3 id="detach-register-unregister">Detach Register, Unregister<a class="headerlink" href="#detach-register-unregister" title="Permanent link">&para;</a></h3>
<p>But what if you want to register a <code>dns</code> name long-term and don't want to sacrifice a terminal to appease <code>autovnet</code>?</p>
<p>Use the <code>-d</code> flag to create the registration, without waiting for a <code>CTRL+C</code> to unregister.
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>register<span class="w"> </span>-d
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Connecting...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns<span class="w"> </span>ready!
swift.man.avn:10.250.116.17

$
</code></pre></div></p>
<p>Test the registration.
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>dig<span class="w"> </span>swift.man.avn<span class="w"> </span>+short<span class="w">      </span>
<span class="m">10</span>.250.116.170
</code></pre></div></p>
<p>Manually <code>unregister</code> when you are done, using <code>NAME</code> or <code>NAME:IP</code> syntax</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>unregister<span class="w"> </span>swift.man.avn
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Connecting...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns<span class="w"> </span>ready!
</code></pre></div>
<p>Now the registration is gone.
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>dig<span class="w"> </span>swift.man.avn<span class="w"> </span>+short<span class="w">      </span>

$
</code></pre></div></p>
<h3 id="save-load-from-file">Save / Load From File<a class="headerlink" href="#save-load-from-file" title="Permanent link">&para;</a></h3>
<p>Want to do something fancy with your <code>dns</code> registerations?</p>
<p>Want to register or unregister domains in batches?</p>
<p>You can save or load registrations from a simple text file!</p>
<p>Here, we create <code>10</code> registrations and save them to a file we can use later.</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>register<span class="w"> </span>-c<span class="w"> </span><span class="m">10</span><span class="w"> </span>-d<span class="w"> </span>-o<span class="w"> </span>/tmp/domains.list
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Connecting...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns<span class="w"> </span>ready!
ordinary.scene.avn:10.246.79.98
absorbed.airport.avn:10.208.15.185
thin.force.avn:10.200.118.131
superb.newspaper.avn:10.236.181.236
tranquil.difference.avn:10.206.67.106
loving.revolution.avn:10.231.243.114
incandescent.cream.avn:10.255.164.126
voracious.price.avn:10.198.71.155
determined.laugh.avn:10.194.16.55
slimy.blind.avn:10.216.146.132
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Created<span class="w"> </span>/tmp/domains.list
</code></pre></div>
<p>Now that we have text file, we can do all kinds of neat tricks.</p>
<p>Print a random domain name from the file:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>cat<span class="w"> </span>/tmp/domains.list<span class="w"> </span><span class="p">|</span><span class="w"> </span>cut<span class="w"> </span>-d:<span class="w"> </span>-f1<span class="w"> </span><span class="p">|</span><span class="w"> </span>sort<span class="w"> </span>-R<span class="w"> </span><span class="p">|</span><span class="w"> </span>head<span class="w"> </span>-n<span class="w"> </span><span class="m">1</span>
superb.newspaper.avn

$<span class="w"> </span>cat<span class="w"> </span>/tmp/domains.list<span class="w"> </span><span class="p">|</span><span class="w"> </span>cut<span class="w"> </span>-d:<span class="w"> </span>-f1<span class="w"> </span><span class="p">|</span><span class="w"> </span>sort<span class="w"> </span>-R<span class="w"> </span><span class="p">|</span><span class="w"> </span>head<span class="w"> </span>-n<span class="w"> </span><span class="m">1</span>
voracious.price.avn
</code></pre></div></p>
<p>You can also easily test all your registrations like:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>cat<span class="w"> </span>/tmp/domains.list<span class="p">|</span><span class="w"> </span>cut<span class="w"> </span>-d:<span class="w"> </span>-f1<span class="w"> </span><span class="p">|</span><span class="w"> </span>xargs<span class="w"> </span>-ti<span class="w"> </span>-n<span class="w"> </span><span class="m">1</span><span class="w"> </span>dig<span class="w"> </span><span class="o">{}</span><span class="w"> </span>+short
dig<span class="w"> </span>ordinary.scene.avn<span class="w"> </span>+short
<span class="m">10</span>.246.79.98
dig<span class="w"> </span>absorbed.airport.avn<span class="w"> </span>+short
<span class="m">10</span>.208.15.185
dig<span class="w"> </span>thin.force.avn<span class="w"> </span>+short
<span class="m">10</span>.200.118.131
dig<span class="w"> </span>superb.newspaper.avn<span class="w"> </span>+short
<span class="m">10</span>.236.181.236
dig<span class="w"> </span>tranquil.difference.avn<span class="w"> </span>+short
<span class="m">10</span>.206.67.106
dig<span class="w"> </span>loving.revolution.avn<span class="w"> </span>+short
<span class="m">10</span>.231.243.114
dig<span class="w"> </span>incandescent.cream.avn<span class="w"> </span>+short
<span class="m">10</span>.255.164.126
dig<span class="w"> </span>voracious.price.avn<span class="w"> </span>+short
<span class="m">10</span>.198.71.155
dig<span class="w"> </span>determined.laugh.avn<span class="w"> </span>+short
<span class="m">10</span>.194.16.55
dig<span class="w"> </span>slimy.blind.avn<span class="w"> </span>+short
<span class="m">10</span>.216.146.132
</code></pre></div></p>
<p>Or you simply count the number of successful resolutions:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>cat<span class="w"> </span>/tmp/domains.list<span class="p">|</span><span class="w"> </span>cut<span class="w"> </span>-d:<span class="w"> </span>-f1<span class="w"> </span><span class="p">|</span><span class="w"> </span>xargs<span class="w"> </span>-i<span class="w"> </span>-n<span class="w"> </span><span class="m">1</span><span class="w"> </span>dig<span class="w"> </span><span class="o">{}</span><span class="w"> </span>+short<span class="w"> </span><span class="p">|</span><span class="w"> </span>wc<span class="w"> </span>-l
<span class="m">10</span>
</code></pre></div></p>
<p>You can also unregister in bulk:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>unregister<span class="w"> </span>-i<span class="w"> </span>/tmp/domains.list
...
</code></pre></div></p>
<p>And confirm they are gone:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>cat<span class="w"> </span>/tmp/domains.list<span class="p">|</span><span class="w"> </span>cut<span class="w"> </span>-d:<span class="w"> </span>-f1<span class="w"> </span><span class="p">|</span><span class="w"> </span>xargs<span class="w"> </span>-i<span class="w"> </span>-n<span class="w"> </span><span class="m">1</span><span class="w"> </span>dig<span class="w"> </span><span class="o">{}</span><span class="w"> </span>+short<span class="w"> </span><span class="p">|</span><span class="w"> </span>wc<span class="w"> </span>-l
<span class="m">0</span>
</code></pre></div></p>
<p>And finally, you can re-register the batch all at once
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>dns<span class="w"> </span>register<span class="w"> </span>-d<span class="w"> </span>-i<span class="w"> </span>/tmp/domains.list
...

$<span class="w"> </span>cat<span class="w"> </span>/tmp/domains.list<span class="p">|</span><span class="w"> </span>cut<span class="w"> </span>-d:<span class="w"> </span>-f1<span class="w"> </span><span class="p">|</span><span class="w"> </span>xargs<span class="w"> </span>-i<span class="w"> </span>-n<span class="w"> </span><span class="m">1</span><span class="w"> </span>dig<span class="w"> </span><span class="o">{}</span><span class="w"> </span>+short<span class="w"> </span><span class="p">|</span><span class="w"> </span>wc<span class="w"> </span>-l
<span class="m">10</span>
</code></pre></div></p>
<p>See the <a href="../../help/#autovnet-rtfm-dns-register">help menu</a> for more ideas and try it out!</p>
<h3 id="but-i-cant-connect-to-the-random-ip">But I can't connect to the random IP?<a class="headerlink" href="#but-i-cant-connect-to-the-random-ip" title="Permanent link">&para;</a></h3>
<p>The <code>register</code> command creates <code>dns</code> <em>records</em>.</p>
<p>It does not reserve the IP addresses shown or cause the IP shown to point to your machine.</p>
<p>If you want to actually use the random IP that <code>register</code> might print out, you can use the <a href="../listen/"><code>listen</code>'s <code>-n</code> option</a>.</p>
<p>Create a service to share:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>python<span class="w"> </span>-m<span class="w"> </span>http.server
Serving<span class="w"> </span>HTTP<span class="w"> </span>on<span class="w"> </span><span class="m">0</span>.0.0.0<span class="w"> </span>port<span class="w"> </span><span class="m">8000</span><span class="w"> </span><span class="o">(</span>http://0.0.0.0:8000/<span class="o">)</span><span class="w"> </span>...
</code></pre></div></p>
<p>Use -n to request the IP rolled by register:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span>-n<span class="w"> </span><span class="m">10</span>.229.134.116<span class="w"> </span><span class="m">80</span><span class="w"> </span>-p<span class="w"> </span><span class="m">8000</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span>wakeful_market
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>wakeful_market<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">10</span>.229.134.116:80<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.0.0.1:8000
</code></pre></div></p>
<p>Now, you can access your webserver using your registered <code>dns</code> name
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>curl<span class="w"> </span>longing.salary.avn
&lt;!DOCTYPE<span class="w"> </span>HTML<span class="w"> </span>PUBLIC<span class="w"> </span><span class="s2">&quot;-//W3C//DTD HTML 4.01//EN&quot;</span><span class="w"> </span><span class="s2">&quot;http://www.w3.org/TR/html4/strict.dtd&quot;</span>&gt;
&lt;html&gt;
&lt;head&gt;
&lt;meta<span class="w"> </span>http-equiv<span class="o">=</span><span class="s2">&quot;Content-Type&quot;</span><span class="w"> </span><span class="nv">content</span><span class="o">=</span><span class="s2">&quot;text/html; charset=utf-8&quot;</span>&gt;
&lt;title&gt;Directory<span class="w"> </span>listing<span class="w"> </span><span class="k">for</span><span class="w"> </span>/&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;h1&gt;Directory<span class="w"> </span>listing<span class="w"> </span><span class="k">for</span><span class="w"> </span>/&lt;/h1&gt;
&lt;hr&gt;
&lt;ul&gt;
&lt;/ul&gt;
&lt;hr&gt;
&lt;/body&gt;
&lt;/html&gt;
</code></pre></div></p>
<h2 id="listen-integration"><code>listen</code> integration<a class="headerlink" href="#listen-integration" title="Permanent link">&para;</a></h2>
<p>To potentionally save you a step, you can register <code>dns</code> names at the same time you create a manual <code>listen</code> command.</p>
<p>Assuming you have an http server like:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>python<span class="w"> </span>-m<span class="w"> </span>http.server<span class="w"> </span>
Serving<span class="w"> </span>HTTP<span class="w"> </span>on<span class="w"> </span><span class="m">0</span>.0.0.0<span class="w"> </span>port<span class="w"> </span><span class="m">8000</span><span class="w"> </span><span class="o">(</span>http://0.0.0.0:8000/<span class="o">)</span><span class="w"> </span>...
</code></pre></div></p>
<p>You can expose it with <code>listen</code> and register a random <code>dns</code> name:</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span><span class="m">80</span><span class="w"> </span>-p<span class="w"> </span><span class="m">8000</span><span class="w"> </span>-R
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span>nippy_many
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>nippy_many<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">10</span>.199.44.94:80<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.0.0.1:8000
afraid.client.avn:10.199.44.94
</code></pre></div>
<p>Now you can access your web server using your registered <code>dns</code> name:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>curl<span class="w"> </span>afraid.client.avn
...
</code></pre></div></p>
<p>You can also register a particular <code>dns</code> name:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span><span class="m">80</span><span class="w"> </span>-p<span class="w"> </span><span class="m">8000</span><span class="w"> </span>-r<span class="w"> </span>foo.avn
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span>abhorrent_field
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>abhorrent_field<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">10</span>.219.240.234:80<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.0.0.1:8000
foo.avn:10.219.240.234
</code></pre></div></p>
<p>And if you later restart the <code>listen</code> by codename, the <code>dns</code> name is re-registered:</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span>abhorrent_field
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span>abhorrent_field
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>abhorrent_field<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">10</span>.219.240.234:80<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.0.0.1:8000
foo.avn:10.219.240.234
</code></pre></div>
<h2 id="tun-integration"><code>tun</code> integration<a class="headerlink" href="#tun-integration" title="Permanent link">&para;</a></h2>
<p>You can also register <code>dns</code> names when you run <code>tun</code> commands.</p>
<p>Assuming you have an http server like:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>python<span class="w"> </span>-m<span class="w"> </span>http.server<span class="w"> </span>
Serving<span class="w"> </span>HTTP<span class="w"> </span>on<span class="w"> </span><span class="m">0</span>.0.0.0<span class="w"> </span>port<span class="w"> </span><span class="m">8000</span><span class="w"> </span><span class="o">(</span>http://0.0.0.0:8000/<span class="o">)</span><span class="w"> </span>...
</code></pre></div></p>
<p>You can bring up a <code>tun</code> that will register a random <code>dns</code> name on each roll:</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>-R<span class="w"> </span>
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.225.206.231
elite.internet.avn:10.225.206.231
</code></pre></div>
<p>Note that we can only access the <code>tun</code> from a different system - because <code>tun</code>s are weird.
Also, notice that the port is <code>:8000</code>, because <code>tun</code> maps our IP <code>1-1</code>.</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>curl<span class="w"> </span>elite.internet.avn:8000
...
</code></pre></div>
<p>When you roll a new IP, you also roll your random <code>dns</code> name.</p>
<div class="highlight"><pre><span></span><code>...
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:<span class="w"> </span>y
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.247.120.227
wretched.spell.avn:10.247.120.227
</code></pre></div>
<p>The <code>-A</code> option is similar: a random <code>dns</code> name is generated, but the registration will update to point to your new <code>tun</code> IP when you roll.</p>
<p>It can be combined with <code>-R</code>, if desired.
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>-A<span class="w">   </span>
...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.213.225.184
spotty.bonus.avn:10.213.225.184
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:<span class="w"> </span>y
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.203.205.154
spotty.bonus.avn:10.203.205.154
</code></pre></div></p>
<p>Finally, <code>-a</code> is like <code>-A</code>, giving you a <code>dns</code> registration that updates when you roll.
But <code>-a</code> allows you to specify the name to register.</p>
<p>It can also be combined with <code>-R</code>.</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>tun<span class="w"> </span>up<span class="w"> </span>-a<span class="w"> </span>foo.avn
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.210.207.243
foo.avn:10.210.207.243
<span class="o">[</span>&gt;<span class="o">]</span><span class="w"> </span>Roll<span class="w"> </span>new<span class="w"> </span>IP?
<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:<span class="w"> </span>y
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>map_ip:<span class="w"> </span><span class="m">10</span>.225.104.2
foo.avn:10.225.104.2
</code></pre></div>





                
              </article>
            </div>
          
          
        </div>
        
          <button type="button" class="md-top md-icon" data-md-component="top" hidden>
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 20h-2V8l-5.5 5.5-1.42-1.42L12 4.16l7.92 7.92-1.42 1.42L13 8v12Z"/></svg>
  Back to top
</button>
        
      </main>
      
        <footer class="md-footer">
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    
    <script id="__config" type="application/json">{"base": "../../..", "features": ["search.suggest", "search.highlight", "navigation.instant", "navigation.tracking", "navigation.tabs", "navigation.tabs.sticky", "navigation.top", "navigation.expand", "toc.integrate", "toc.follow", "navigation.top", "content.code.copy"], "search": "../../../assets/javascripts/workers/search.f886a092.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version": "Select version"}}</script>
    
    
      <script src="../../../assets/javascripts/bundle.aecac24b.min.js"></script>
      
    
  </body>
</html>